package com.brilliance.isc.funds.basesel.ftdsel.service.impl;

import com.brilliance.isc.bo.FtdVo;
import com.brilliance.isc.bo.Trn;import com.brilliance.isc.common.sysmod.SysmodService;import com.brilliance.isc.funds.basesel.ftdsel.service.FtdselService;
import com.brilliance.isc.funds.bo.funds.FttfcmStoreBo;import com.brilliance.isc.funds.bo.funds.FxtfopStoreBo;import com.brilliance.isc.funds.common.component.FtToolComponent;import com.brilliance.isc.mda.dao.FtdMapper;
import com.brilliance.isc.mda.dao.TrnMapper;import com.brilliance.isc.vo.funds.FtdWithPtsCbbResponseVo;import com.brilliance.isc.vo.funds.FttselQueryVo;import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;import java.util.List;import java.util.Map;import java.util.Objects;

@Service
public class FtdselServiceImpl implements FtdselService {
    @Resource
    private FtdMapper ftdMapper;
    @Resource
    private TrnMapper trnMapper;
    @Resource
    private FtToolComponent ftToolComponent;
    @Resource
    private SysmodService sysmodService;
    @Override
    public PageInfo<FtdWithPtsCbbResponseVo> query(FttselQueryVo  vo) {
        //搜索
        PageHelper.startPage(1, vo.getPageSize()).setReasonable(true);
        List<FtdWithPtsCbbResponseVo> list = ftdMapper.queryFtd(vo);
        return new PageInfo<>(list);
        }
    @Override
    public PageInfo<FtdWithPtsCbbResponseVo> querytcdb(FttselQueryVo vo) {
        List<String> fttypList=new ArrayList<>();
        fttypList.add("PT");
        vo.setFttypList(fttypList);
        PageHelper.startPage(1, vo.getPageSize()).setReasonable(true);
        List<FtdWithPtsCbbResponseVo> list = ftdMapper.queryFtd(vo);
        return new PageInfo<>(list);
    }
    @Override
    public PageInfo<FtdWithPtsCbbResponseVo> queryzjcj(FttselQueryVo vo) {
         List<String> fttypList=new ArrayList<>();
         fttypList.add("LI");
         fttypList.add("LO");
         fttypList.add("DI");
         fttypList.add("DO");
         vo.setFttypList(fttypList);
         PageHelper.startPage(1, vo.getPageSize()).setReasonable(true);
         List<FtdWithPtsCbbResponseVo> list = ftdMapper.queryFtd(vo);
         return new PageInfo<>(list);
    }

    @Override
    public Object selectXxdByPrimaryKey(Map<String, String> map) {
        String objinr = map.get("objinr");
        String objtyp = map.get("objtyp");
        String pntinr = map.get("pntinr");
        FttfcmStoreBo fttfcmStoreBo = new FttfcmStoreBo();
        fttfcmStoreBo.reset();
        if(objinr.length() == 16) {
            Trn trnLid = trnMapper.selectByObjinrTrn(objtyp, objinr, "FTTFCM");
            if (!Objects.isNull(trnLid)) {
               fttfcmStoreBo = sysmodService.streamGetNameInSubDir(FttfcmStoreBo.class, trnLid.getInr());
            }
        }
        fttfcmStoreBo.setFtdgrp(ftToolComponent.getFtdgrpByInr(objinr));
        return fttfcmStoreBo;
    }

//        String branch = fxtselQueryVo.getBranch();
//        if (Strings.isEmpty(branch)) {
//            branch = SettleContext.getSessionUserVo().getOwnOrgDepartmentNumber();
//        }
//        Bch bch = bchService.getDirectAccBch(branch); //获取到当前登录柜员的记账机构
//        if (Objects.isNull(bch) && !Objects.equals(branch, "1000")) {//非总行机构一定会获取到记账机构，如果没获取到则抛出异常
//            SettleExceptionUtils.sysDump("未获取到机构信息！");
//        }
//        if(!Objects.isNull(bch)){
//            fxtselQueryVo.setBchinr(bch.getInr());
//            //查询归属机构集合
//            List<Bch> bchList = bchService.listAllChildSubBchByAccBch(bch.getBranch());
//            if (bchList != null) {
//                fxtselQueryVo.setBchLst(bchList);
//            }
//        }
//        PageHelper.startPage(fxtselQueryVo.getPageNumber(), fxtselQueryVo.getPageSize()).setReasonable(true);
//        List<CpdWithPtsCbbResponseVo> cpdList = cpdMapper.queryCpd(fxtselQueryVo);
//        for (CpdWithPtsCbbResponseVo cpd:cpdList) {
//            if(!MdaUtils.isEmpty(cpd.getPyeExtkey())) {
//                cpd.setPyeExtkey(cpd.getPyeExtkey().split("-")[0]);
//            }
//            if(!MdaUtils.isEmpty(cpd.getOrcExtkey())) {
//                cpd.setOrcExtkey(cpd.getOrcExtkey().split("-")[0]);
//            }
//        }
//        return new PageInfo(cpdList);





}
