package com.brilliance.isc.funds.basesel.trncod.service.impl;


import com.brilliance.isc.bo.model.Ftdgrp;
import com.brilliance.isc.common.cbsmod.service.CbsmodService;
import com.brilliance.isc.common.sysmod.SysmodService;
import com.brilliance.isc.funds.common.component.FtToolComponent;
import com.brilliance.isc.funds.basesel.trncod.service.TrncodService;
import com.brilliance.isc.mda.dao.BusbtnMapper;
import com.brilliance.isc.mda.dao.TrnMapper;
import com.brilliance.isc.vo.TrnCodeQueryVo;
import com.brilliance.isc.vo.TrncodVo;
import com.google.common.collect.Lists;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service
public class TrncodServiceImpl implements TrncodService {

    @Resource
    private BusbtnMapper busbtnMapper;
    @Resource
    private TrncodService trncodService;

    @Resource
    private TrnMapper trnMapper;
    @Resource
    private SysmodService sysmodService;
    @Resource
    private CbsmodService cbsmodService;

    @Resource
    private FtToolComponent ftToolComponent;

    @Override
    public List<TrncodVo> dealWithByInr(TrnCodeQueryVo trnCodeQueryVo) {
        List<TrncodVo> result = Lists.newArrayList();
        //获取模型数据
        Ftdgrp ftdgrp = ftToolComponent.getFtdgrpByInr(trnCodeQueryVo.getInr());
        String isAllowed = "";
        String[] fxTraArray = {"FTTFMT", "FTTFCN","FTTPCN"};
        String[] fxButArray = {"资金拆借到期", "资金拆借销账","头寸调拨销账"};

        for (int i = 0; i < fxTraArray.length; i++) {

            TrncodVo trncodVo = new TrncodVo(fxTraArray[i],fxButArray[i],isAllowed,"Y","");
            ftToolComponent.isFTTrnAllowed(ftdgrp,trncodVo);
            result.add(trncodVo);
        }
        return result;
    }


    @Override
    public Object selectXxdByPrimaryKey(Map<String, String> map) {
        String objinr = map.get("objinr");
        String objtyp = map.get("objtyp");
//      String pntinr = map.get("pntinr");
        String paytyp = map.get("paytyp");

        return null;
    }

}
