package com.brilliance.isc.funds.common.controller;

import com.brilliance.isc.common.api.lim.controller.AbstractLimController;
import com.brilliance.isc.common.api.lim.vo.LimRequest;
import com.brilliance.isc.common.api.lim.vo.LimResponse;
import com.brilliance.isc.common.api.lim.vo.YapinRequest;
import com.brilliance.isc.common.api.lim.vo.YapinResponse;
import com.brilliance.isc.vo.ResponseSet;
import com.brilliance.isc.vo.funds.FxdBizAmdInfoVo;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 额度组件
 */
@RestController
@RequestMapping("/fxd")
public class FxdLimController extends AbstractLimController<FxdBizInfoVo, FxdBizAmdInfoVo> {
    /**
     * 额度初始化
     *
     * @param limRequest
     * @return
     */

    @RequestMapping("/lim/limInit")
    @Override
    public ResponseSet<LimResponse> limInit(@RequestBody LimRequest<FxdBizInfoVo, FxdBizAmdInfoVo> limRequest) {
        return super.limInit(limRequest);
    }

    /**
     * 额度查询入口
     *
     * @param limRequest
     * @return
     */

    @RequestMapping("/lim/limQuery")
    @Override
    public ResponseSet<LimResponse> limQuery(@RequestBody LimRequest<FxdBizInfoVo, FxdBizAmdInfoVo> limRequest) {
        return super.limQuery(limRequest);
    }

    /**
     * 额度试算入口
     *
     * @param limRequest
     * @return
     */

    @RequestMapping("/lim/limPreCal")
    @Override
    public ResponseSet<LimResponse> limPreCal(@RequestBody LimRequest<FxdBizInfoVo, FxdBizAmdInfoVo> limRequest) {
        return super.limPreCal(limRequest);
    }

    /**
     * 转授权查询
     *
     * @param limRequest
     * @return
     */

    @RequestMapping("/lim/limZsqQuery")
    @Override
    public ResponseSet<LimResponse> limZsqQuery(@RequestBody LimRequest<FxdBizInfoVo, FxdBizAmdInfoVo> limRequest) {
        return super.limZsqQuery(limRequest);
    }

    @RequestMapping("/lim/yapinQuery")
    public ResponseSet<YapinResponse> yapinQuery(@RequestBody YapinRequest<FxdBizInfoVo, FxdBizAmdInfoVo> yapinRequest) {
        return super.yapinQuery(yapinRequest);
    }
}
