package com.brilliance.isc.funds.crtcro.register.settle;

import com.brilliance.isc.common.component.PtsptaToolComponent;
import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.common.vo.PtsptaVo;
import com.brilliance.isc.funds.crtcro.service.CrtcroTransactionServiceImpl;
import com.brilliance.isc.vo.funds.CrdBizInfoVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

/**
 * @program: isc-funds
 * @ClassName: CrtcroSettleRegister
 * @description: 汇入清算 Crtcro 结算注册
 * @author: huangshunlin
 * @create: 2024-10-16 20:27
 */
@Component("crtcro.settleRegister")
public class CrtcroSettleRegister implements ISettleRegister {

    @Autowired
    private SetglgService setglgService;

    @Autowired
    private DefaultSettleRegister defaultSettleRegister;

    @Autowired
    private SetmodService setmodService;

    @Autowired
    private PtsptaToolComponent ptsptaToolComponent;


    @Resource(name = "crtcro.transaction")
    CrtcroTransactionServiceImpl fxtsssTransactionService;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    /**
     * source:crtcro.0002.script
     */
    private void transRegister(SetmodVo setmodVo) {
        CrdBizInfoVo rec = (CrdBizInfoVo) setmodVo.getRec();
        BigDecimal maxAmt = BigDecimal.ZERO;
        if (setmodVo.getCbsMap().get("MAX") != null) {
            maxAmt = setmodVo.getCbsMap().get("MAX").getAmt();
        }
        setmodVo.setDocamt(maxAmt);
        SetglgVo setglg = setmodVo.getSetglg();
        setglgService.setglgClrAmount(setglg, "TRN");

        String dbtKey = setglgService.setglgAddAmount(setglg, "TRN", "OWN", setmodVo.getDoccur(), maxAmt, "", "SPD",
                "A", rec.getSpcgleAct(), "");
        String rol = NULLSTR;
        List<PtsptaVo> ptsList = setmodVo.getPtsList();
//            if (this.getCrdgrp().getAcc().isRolSet()) {
        if (ptsptaToolComponent.ptsIsRolSet(ptsList, "ACC")) {
            rol = "ACC";
        } else {
            rol = "RCV";
        }

        String cdtKey = setmodService.setGlgAmt(setmodVo, "TRN", rol, setmodVo.getDoccur(), maxAmt.negate(), "");
//    TODO    this.getTrnmod().getTrnism().setDefDsp(rol, "C", "PAC" + CR + "VOC");
        Date valDat = rec.getOpndat();
        switch (rec.getRcvobjtyp()) {
            case "CPD":
                valDat = rec.getValdat();
                break;
            case "GID":
                break;
            case "BCD":
                break;
            case "BRD":
                break;
        }
        setglgService.setglgAddAmtFldValDat(setglg, "TRN", cdtKey, valDat);
    }
}
