package com.brilliance.isc.funds.fttfmt.service;

import com.brilliance.isc.bo.Ftd;import com.brilliance.isc.bo.Fxd;
import com.brilliance.isc.bo.model.Ftdgrp;import com.brilliance.isc.bo.model.Fttp;import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.bo.Smh;
import com.brilliance.isc.bo.Pty;
import com.brilliance.isc.common.api.bch.service.BchService;
import com.brilliance.isc.common.cache.pta.PtaCacheService;
import com.brilliance.isc.common.cbsmod.service.CbsmodService;
import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.contants.CommonContants;
import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.liaall.service.LiaallService;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.sysmod.SysmodService;
import com.brilliance.isc.common.transaction.AbstractTransactionService;
import com.brilliance.isc.common.transaction.help.TransactionHelpService;
import com.brilliance.isc.common.transaction.help.TransactionServiceSet;
import com.brilliance.isc.common.trnmod.service.TrnmodService;
import com.brilliance.isc.common.trnmod.vo.TrnmodVo;
import com.brilliance.isc.common.util.I18nUtil;
import com.brilliance.isc.common.vo.BizAmdInfoVo;
import com.brilliance.isc.common.vo.BizInfoVo;
import com.brilliance.isc.funds.bo.funds.FttfmtStoreBo;import com.brilliance.isc.funds.bo.funds.FxtfcnStoreBo;
import com.brilliance.isc.funds.common.component.FtToolComponent;import com.brilliance.isc.funds.common.component.FxToolComponent;
import com.brilliance.isc.funds.fttfmt.check.FttfmtValidator;import com.brilliance.isc.funds.fxtfcn.check.FxtfcnValidator;
import com.brilliance.isc.funds.fxtlop.service.FxtpService;
import com.brilliance.isc.funds.vo.funds.FxtfcnStoreVo;
import com.brilliance.isc.mda.dao.PtyratMapper;
import com.brilliance.isc.mda.dao.SmhMapper;
import com.brilliance.isc.vo.funds.FtdBizInfoVo;import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.brilliance.isc.mda.dao.ActMapper;
import com.brilliance.isc.mda.dao.PtyMapper;
import com.brilliance.isc.common.component.SptDataComponent;
import com.brilliance.isc.common.component.PtsptaToolComponent;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;import static com.brilliance.mda.runtime.mda.Constants.*;


@Service("fttfmt.transaction")
public class FttfmtTransactionServiceImpl extends AbstractTransactionService<FttfmtStoreBo> {
    @Resource
    private FttfmtValidator fttfmtValidator;
//    @Autowired
//    private FxtfcnService fxtfcnService;
    @Resource
    private TrnmodService trnmodService;
    @Resource
    private XrtmodService xrtmodService;
    @Resource
    private FtToolComponent ftToolComponent;
    @Resource
    private TransactionHelpService transactionHelpService;
    @Resource
    private CbsmodService cbsmodService;
    @Resource
    private LiaallService liaallService;
    @Resource
    private SettleContext settleContext;
    @Autowired
    private PtaCacheService ptaCacheService;

    @Resource
    private BchService bchService;

    @Resource
    private PtyratMapper ptyratMapper;

    @Resource
    private SmhMapper smhMapper;

    @Resource
    private ActMapper actMapper;

    @Resource
    private PtyMapper ptyMapper;

    @Resource
    private SetmodService setmodService;

    @Resource
    private SysmodService sysmodService;

    @Autowired
    SptDataComponent sptDataComponent;

    @Autowired
    PtsptaToolComponent ptsptaToolComponent;

    @PostConstruct
    public void regisertService() {
        serviceRegisterMaps.put(CommonContants.SETMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNDOC_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.GLEMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNDIA_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNMOD_SERVICE, "Y");

//        serviceRegisterMaps.put(CommonContants.UMDMOD_SERVICE, "N");
//        serviceRegisterMaps.put(CommonContants.LIMMOD_SERVICE, "Y");
//        serviceRegisterMaps.put(CommonContants.BOPSET_RMB_SERVICE, "Y");
//        serviceRegisterMaps.put(CommonContants.BOPSET_SZSB_BOPREM_SERVICE, "Y");
//        serviceRegisterMaps.put(CommonContants.BOPSET_CFABOP_SERVICE, "Y");
//        serviceRegisterMaps.put(CommonContants.FANXIQIAN_SERVICE, "Y");
    }

    @Override
    protected void txnSave(FttfmtStoreBo transactionVo) {
        ruleMtabutSavN500(transactionVo);
    }

    @Override
    protected Map<String, String> txnCheck(FttfmtStoreBo transactionVo) {
        return fttfmtValidator.validate(transactionVo);
    }

    @Override
    protected BizInfoVo buildBizInfo(FttfmtStoreBo transactionVo) {
         FtdBizInfoVo bizInfoVo = new FtdBizInfoVo();
         bizInfoVo.setObjtyp("FTD");
         Ftd rec = transactionVo.getFtdgrp().getRec();
         bizInfoVo.setObjinr(rec.getInr());
         bizInfoVo.setOwnref(rec.getOwnref());
         bizInfoVo.setFttyp(rec.getFttyp());
         bizInfoVo.setRat(rec.getRat());
         bizInfoVo.setBranchInr(rec.getBranchinr());
         bizInfoVo.setEtyextkey(rec.getEtyextkey());
         bizInfoVo.setBranchInr(rec.getBranchinr());
         bizInfoVo.setValdat(rec.getValdat());

        return bizInfoVo;
    }

    @Override
    protected BizAmdInfoVo buildBizAmdInfo(FttfmtStoreBo transactionVo) {
        return null;
    }

    @Override
    public FttfmtStoreBo init(FttfmtStoreBo fttfmtStoreBo) {
        fttfmtStoreBo.reset();
        String ftdinr = fttfmtStoreBo.getFtdgrp().getRec().getInr();
        if (sptDataComponent.needMergeSptData(fttfmtStoreBo)) {
            ftdinr = fttfmtStoreBo.getSpt().getObjinr();
        }

        Ftdgrp ftdgrpVo = ftToolComponent.getFtdgrpByInr(ftdinr);
        fttfmtStoreBo.setFtdgrp(ftdgrpVo);
        fttfmtStoreBo.getFtdgrp().getRec().setRat(ftdgrpVo.getRec().getRat());
        fttfmtStoreBo.getFtdgrp().getRec().setMatdat(ftdgrpVo.getRec().getMatdat());
        init950(fttfmtStoreBo);
        init1000(fttfmtStoreBo);
        return fttfmtStoreBo;
    }

    private void init950(FttfmtStoreBo fttfmtStoreBo) {



    }

    private void init1000(FttfmtStoreBo fttfmtStoreBo) {
        String extkey = SettleContext.getUserSession().getUsr().getExtkey();
        fttfmtStoreBo.getFtdgrp().getRec().setOwnusr(extkey);

    }

    @Override
    public void beforeSave(FttfmtStoreBo transactionVo) {
        transactionVo.reset();
        Ftdgrp ftdgrp = transactionVo.getFtdgrp();

        TransactionServiceSet transactionServiceSet = transactionHelpService.getTransactionStoreSet();
        transactionServiceSet.setRec(ftdgrp.getRec());
        transactionServiceSet.setBlk(ftdgrp.getBlk());
        transactionServiceSet.setTransactionVo(transactionVo);
        ftToolComponent.collectCbsMap(transactionServiceSet, "", ftdgrp.getCbs(), "max", "ins", "opn1", "opn2");
        ftToolComponent.collectPtsList(transactionServiceSet, ftdgrp, null);
        settleContext.loadSettleSession(transactionVo.getTransName(), transactionVo.getUserId(), buildBizInfo(transactionVo), transactionServiceSet.getPtsList());
    }

    @Override
    protected void updateBizInfoVo(BizInfoVo bizInfoVo, FttfmtStoreBo transactionVo) {
        bizInfoVo.setObjinr(transactionVo.getFtdgrp().getRec().getInr());
    }

    public void ruleMtabutSavN500(FttfmtStoreBo bo) {
        TrnmodVo trnmodVo = transactionHelpService.getTransactionStoreSet().getTrnmodVo();
        // 1. Create (rsp. update) Contract (incl. Texts)
        ftToolComponent.getref(bo.getFtdgrp());
        bo.getFtdgrp().getRec().setCnfdat(Dates.today());
        ftToolComponent.sav(bo.getFtdgrp());
        // 2. Build Transaction from FTDGRP
        trnmodService.trnSetFromContract(trnmodVo);
        // Store CBS-Info
        cbsSav(bo,trnmodVo);
        // Store CBS of Nostro
        //transactionVo.getNosmod().savNostro();

    }

    public void cbsSav(FttfmtStoreBo transactionVo, TrnmodVo trnmodVo) {
        String trninr = transactionHelpService.getTrninr();
        cbsmodService.cbsTrnSetNew("TRN",trninr);

        if (MdaUtils.compareTo(transactionVo.getFtdgrp().getRec().getFttyp(),"LO") == 0|| MdaUtils.compareTo(transactionVo.getFtdgrp().getRec().getFttyp(),"DO") == 0 ){
                trnmodService.cbsTrnStore("OPNAMT","AMT1",Dates.today(),transactionVo.getSetmod().getDoccur(),transactionVo.getSetmod().getSetamt(),"Settling a Funds Transfer",transactionVo.getFtdgrp(),trninr);
        }

        trnmodService.cbsTrnStore("UTLAMT","AMT1",Dates.today(),transactionVo.getFtdgrp().getCbs().getOpn1().getCur(),transactionVo.getFtdgrp().getCbs().getOpn1().getAmt(), "Settling a Funds Transfer",transactionVo.getFtdgrp(),trninr);
        trnmodService.cbsTrnStore("INSAMT","AMT1",Dates.today(),transactionVo.getFtdgrp().getCbs().getIns().getCur(),transactionVo.getFtdgrp().getCbs().getIns().getAmt(), "Settling a Funds Transfer",transactionVo.getFtdgrp(),trninr);
        cbsmodService.cbsTrnCommit();

    }


    public boolean defaultFtdgrpRecGznoN1000(FttfmtStoreBo fttfmtStoreBo){
        switch( fttfmtStoreBo.getFtdgrp().getRec().getFttyp())
    			{
    			  case "LI":
    			  case "DI":
    			  case "LO":
    			  case "DO":
    		//	  Systems.setEnabled(this.getFtdgrp().getRec(),"gzno");
    			  /**
    			    #做资金拆出时，国结系统中挂账编号没有存储，需手工输入，故把拆出的业务也把此栏位放开
    			    case "LO", "DO"
    			    Disable( FTDGRP\\REC\\GZNO )
    			    **/
    			  break;
    			}
    			return true;
            }



}
