package com.brilliance.isc.funds.fxtfop.check;

import com.brilliance.isc.bo.Fxd;
import com.brilliance.isc.common.transaction.newcheck.AbstractModuleValidator;
import com.brilliance.isc.common.transaction.newcheck.ValidResult;
import com.brilliance.isc.common.transaction.newcheck.Validate;
import com.brilliance.isc.funds.bo.funds.FxtfopStoreBo;
import com.brilliance.isc.funds.bo.funds.FxtssbStoreBo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.Map;


@Component
public class FxtfopValidator extends AbstractModuleValidator<FxtfopStoreBo> {


    @Override
    @PostConstruct
    public void register() {
        super.register();
    }

    @Override
    public Map<String, String> validate(FxtfopStoreBo vo) {
        Map<String, String> maps = new HashMap<>();
        maps.putAll(super.validate(vo));
        return maps;
    }

    /**
     *   source:fxtfop.0011.script
     */
    @Validate(path="fxdgrp.rec.opndat")
    public ValidResult checkFxdgrpRecOpndatN1000(FxtfopStoreBo bo){
        Fxd rec = bo.getFxdgrp().getRec();

        if( MdaUtils.isEmpty(rec.getOpndat()) )
        {
            return errorMandatory();
        }


        return null;
    }

    /**
     *   source:fxtfop.0012.script
     */
    @Validate(path="fxdgrp.rec.valdat")
    public ValidResult checkFxdgrpRecValdatN1000(FxtfopStoreBo bo){
        Fxd rec = bo.getFxdgrp().getRec();

        if( MdaUtils.isEmpty(rec.getValdat()) )
        {
            return errorMandatory();
        }


        return null;
    }

    /**
     *   source:fxtfop.0013.script
     */
    @Validate(path="fxdgrp.rec.rat")
    public ValidResult checkFxdgrpRecRatN1000(FxtfopStoreBo bo){
        Fxd rec = bo.getFxdgrp().getRec();

        if( MdaUtils.isEmpty(rec.getRat()) )
        {
            return errorMandatory();
        }


        return null;
    }

    /**
     *   source:fxtfop.0014.script
     */
    @Validate(path="fxdgrp.apl.pts.extkey")
    public ValidResult checkFxdgrpAplPtsExtkeyN1000(FxtfopStoreBo bo){

        if( MdaUtils.isEmpty(bo.getFxdgrp().getApl().getPts().getExtkey()) )
        {
            return errorMandatory();
        }


        return null;
    }




}
