package com.brilliance.isc.funds.fxtlcm.check;

import com.brilliance.isc.common.transaction.newcheck.AbstractModuleValidator;
import com.brilliance.isc.common.transaction.newcheck.ValidResult;
import com.brilliance.isc.common.transaction.newcheck.Validate;
import com.brilliance.isc.funds.bo.funds.FxtlcmStoreBo;
import com.brilliance.isc.funds.bo.funds.FxtlcmStoreBo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.Map;

/**
 * @program: isc-funds
 * @ClassName: FxtlcmValidator
 * @description: 结售汇平盘确认 Fxtlcm 校验
 * @author: 肖桐
 * @create: 2024-10-14 14:12
 */
@Component
public class FxtlcmValidator extends AbstractModuleValidator <FxtlcmStoreBo>{

    @Override
    @PostConstruct
    public void register(){
        super.register();;
    }

    @Override
    public Map<String, String> validate(FxtlcmStoreBo bo) {
        Map<String, String> maps = new HashMap<>();
        maps.putAll(super.validate(bo));
        return maps;
    }

    /**
     *   source:Fxtlcm.0023.script
     */
    @Validate(path="fxdgrp.apl.pts.ref")
    public ValidResult checkFxdgrpAplPtsRefN1000(FxtlcmStoreBo bo){
        if( ! MdaUtils.isEmpty(bo.getSwtflg()) && ( MdaUtils.compareTo(bo.getMt30m().getS22a(),"AMND") == 0 || MdaUtils.compareTo(bo.getMt30m().getS22a(),"CANC") == 0 ) )
        {
            if( MdaUtils.isEmpty(bo.getFxdgrp().getApl().getPts().getRef()) )
            {
                return  errorMandatory();
            }
        }
        return null;
    }

    /**
     *   source:Fxtlcm.0024.script
     */
    @Validate(path="mt30m.rbc.pts.extkey")
    public ValidResult checkMt30mRbcPtsExtkeyN1000(FxtlcmStoreBo bo){
        if( ! MdaUtils.isEmpty(bo.getSwtflg()) && MdaUtils.isEmpty(bo.getMt30m().getRbc().getPts().getExtkey()) )
        {
            return  errorMandatory();
        }
        return null;
    }

    /**
     *   source:Fxtlcm.0025.script
     */
    @Validate(path="mt30m.owc.pts.extkey")
    public ValidResult checkMt30mOwcPtsExtkeyN1000(FxtlcmStoreBo bo){
        if( ! MdaUtils.isEmpty(bo.getSwtflg()) && MdaUtils.isEmpty(bo.getMt30m().getOwc().getPts().getExtkey()) )
        {
            return errorMandatory();
        }
        return null;
    }


}
