package com.brilliance.isc.funds.fxtsqo.register.diasav;

import com.brilliance.isc.common.register.diasav.CommonDiasavRegister;
import com.brilliance.isc.common.register.diasav.IDiasavRegister;
import com.brilliance.isc.common.trndia.service.TrndiaService;
import com.brilliance.isc.common.trndia.vo.TrndiaVo;
import com.brilliance.isc.common.util.I18nUtil;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import static com.brilliance.mda.runtime.mda.Constants.DiaToReplace;

@Component("fxtsqo.diasavRegister")
public class FxtsqoDiasavRegister implements IDiasavRegister {
    @Autowired
    private CommonDiasavRegister commonDiasavRegister;

    @Autowired
    private TrndiaService trndiaService;

    @Override
    public void diasav(TrndiaVo trndia) {
        this.trnDiasav(trndia);
        commonDiasavRegister.diasav(trndia);
    }

    /**
     * source:fxtsqo.0006.script
     */
    private void trnDiasav(TrndiaVo trndiaVo) {
        FxdBizInfoVo rec = (FxdBizInfoVo) trndiaVo.getRec();
        if (!MdaUtils.isEmpty(rec.getSetdat())) {
            trndiaService.trnDiaSet(trndiaVo, "FXDSET", rec.getSetdat(), "EXP",
                    I18nUtil.getMessage("funds_fxtsqo_000001", rec.getOwnref()), "FXTSST", DiaToReplace);
        }
        trndiaService.trnDiaSetDone(trndiaVo, "QUOTE");
    }
}
