package com.brilliance.isc.funds.transfer.transaction;


import com.brilliance.isc.funds.bo.funds.FttfcnStoreBo;
import com.brilliance.isc.funds.vo.funds.FttfcnStoreVo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.Mappings;
import org.mapstruct.factory.Mappers;

@Mapper(componentModel = "spring")
public interface FttfcnStructMapper extends IBaseStructMapper<FttfcnStoreBo, FttfcnStoreVo> {
    /**
     * 此行语句一定要写，StructMapper需要
     */
    FttfcnStructMapper INSTANCE = Mappers.getMapper(FttfcnStructMapper.class);

    /**
     * Vo转为Bo
     *
     * @param vo
     * @return 返回业务Bo
     */
    @Override
    FttfcnStoreBo voTransferToBo(FttfcnStoreVo vo);

    /**
     * Vo追加更新至Bo
     *
     * @param vo
     * @param bo
     */
    @Override
    @Mappings({

    })
    void voUpdateToBo(FttfcnStoreVo vo, @MappingTarget FttfcnStoreBo bo);

    /**
     * Bo转为Vo
     *
     * @param bo
     * @return 返回Vo
     */
    @Override
    FttfcnStoreVo boTransferToVo(FttfcnStoreBo bo);

    /**
     * bo追加更新至Bo
     *
     * @param bo
     * @param vo
     */
    @Override
    void boUpdateToVo(FttfcnStoreBo bo, @MappingTarget FttfcnStoreVo vo);
}
