package com.brilliance.isc.funds.transfer.transaction;
import com.brilliance.isc.funds.bo.funds.FttfmtStoreBo;
import com.brilliance.isc.funds.vo.funds.FttfmtStoreVo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.Mappings;
import org.mapstruct.factory.Mappers;



@Mapper(componentModel = "spring")
public interface FttfmtStructMapper extends IBaseStructMapper<FttfmtStoreBo, FttfmtStoreVo>{
     /**
         * 此行语句一定要写，StructMapper需要
         */
        FttfmtStructMapper INSTANCE = Mappers.getMapper(FttfmtStructMapper.class);

        /**
         * Vo转为Bo
         *
         * @param vo
         * @return 返回业务Bo
         */
        @Override
        FttfmtStoreBo voTransferToBo(FttfmtStoreVo vo);

        /**
         * Vo追加更新至Bo
         *
         * @param vo
         * @param bo
         */
        @Override
        @Mappings({

        })
        void voUpdateToBo(FttfmtStoreVo vo, @MappingTarget FttfmtStoreBo bo);

        /**
         * Bo转为Vo
         *
         * @param bo
         * @return 返回Vo
         */
        @Override
        FttfmtStoreVo boTransferToVo(FttfmtStoreBo bo);

        /**
         * bo追加更新至Bo
         *
         * @param bo
         * @param vo
         */
        @Override
        void boUpdateToVo(FttfmtStoreBo bo, @MappingTarget FttfmtStoreVo vo);

}
