package com.brilliance.isc.funds.transfer.transaction;


;import com.brilliance.isc.funds.bo.funds.FttpcnStoreBo;
import com.brilliance.isc.funds.vo.funds.FttpcnStoreVo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import org.mapstruct.Mapper;import org.mapstruct.MappingTarget;import org.mapstruct.Mappings;import org.mapstruct.factory.Mappers;



@Mapper(componentModel = "spring")
public interface FttpcnStructMapper extends IBaseStructMapper<FttpcnStoreBo, FttpcnStoreVo> {
      /**
         * 此行语句一定要写，StructMapper需要
         */
        FttpcnStructMapper INSTANCE = Mappers.getMapper(FttpcnStructMapper.class);

        /**
         * Vo转为Bo
         *
         * @param vo
         * @return 返回业务Bo
         */
        @Override
        FttpcnStoreBo voTransferToBo(FttpcnStoreVo vo);

        /**
         * Vo追加更新至Bo
         *
         * @param vo
         * @param bo
         */
        @Override
        @Mappings({

        })
        void voUpdateToBo(FttpcnStoreVo vo, @MappingTarget FttpcnStoreBo bo);

        /**
         * Bo转为Vo
         *
         * @param bo
         * @return 返回Vo
         */
        @Override
        FttpcnStoreVo boTransferToVo(FttpcnStoreBo bo);

        /**
         * bo追加更新至Bo
         *
         * @param bo
         * @param vo
         */
        @Override
        void boUpdateToVo(FttpcnStoreBo bo, @MappingTarget FttpcnStoreVo vo);
}
