package com.brilliance.isc.funds.transfer.transaction;

import com.brilliance.isc.funds.bo.funds.FxtfcnStoreBo;
import com.brilliance.isc.funds.vo.funds.FxtfcnStoreVo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.Mappings;
import org.mapstruct.factory.Mappers;

/**
 * @program: isc-funds
 * @ClassName: FxtfcnStructMapper
 * @description:
 * @author: xiaotong
 * @create: 2024-10-11 17:17
 */
@Mapper(componentModel = "spring")
public interface FxtfcnStructMapper extends IBaseStructMapper<FxtfcnStoreBo, FxtfcnStoreVo> {
    /**
     * 此行语句一定要写，StructMapper需要
     */
    FxtfcnStructMapper INSTANCE = Mappers.getMapper(FxtfcnStructMapper.class);

    /**
     * Vo转为Bo
     *
     * @param vo
     * @return 返回业务Bo
     */
    @Override
    FxtfcnStoreBo voTransferToBo(FxtfcnStoreVo vo);

    /**
     * Vo追加更新至Bo
     *
     * @param vo
     * @param bo
     */
    @Override
    @Mappings({

    })
    void voUpdateToBo(FxtfcnStoreVo vo, @MappingTarget FxtfcnStoreBo bo);

    /**
     * Bo转为Vo
     *
     * @param bo
     * @return 返回Vo
     */
    @Override
    FxtfcnStoreVo boTransferToVo(FxtfcnStoreBo bo);

    /**
     * bo追加更新至Bo
     *
     * @param bo
     * @param vo
     */
    @Override
    void boUpdateToVo(FxtfcnStoreBo bo, @MappingTarget FxtfcnStoreVo vo);
}
