package com.brilliance.isc.funds.vo.funds;

import com.brilliance.isc.bo.Smh;
import com.brilliance.isc.bo.model.Cpdgrp;
import com.brilliance.isc.common.nosmod.vo.NosmodVo;
import com.brilliance.isc.common.transaction.vo.BaseTransactionVo;
import com.brilliance.isc.common.vo.GleVo;
import com.brilliance.isc.model.act.ActVO;
import com.brilliance.isc.vo.funds.CrdgrpVo;
import com.brilliance.isc.vo.funds.CrtmodVo;
import com.brilliance.isc.vo.manager.SmhVo;
import com.brilliance.isc.vo.manager.TrnVo;
import com.brilliance.isc.vo.model.Bcdgrp;
import com.brilliance.isc.vo.model.Brdgrp;
import com.brilliance.isc.vo.model.Gidgrp;
import com.brilliance.isc.vo.model.Lidgrp;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

/**
 * @program: isc-funds
 * @ClassName: CrtcriStoreVo
 * @description: 汇出清算 bo
 * @author: huangshunlin
 * @create: 2024-10-17 22:33
 */
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class CrtcroStoreVo extends BaseTransactionVo {

    //Direct payment one message (max=1)
    private String dirindflg = NULLSTR;
    //Which MT to beneficiary institution  (max=3)
    private String sftmt = NULLSTR;
    //Message Init Flag (max=1)
    private String msgflg = NULLSTR;
    //21 TAG for MTs  (max=16)
    private String tag21 = NULLSTR;
    //Amount   (scale=3)
    private BigDecimal amt32 = new BigDecimal("0.00");
    //Amount  (scale=3)
    private BigDecimal amt33 = new BigDecimal("0.00");
    //Currency (max=3)
    private String cur32 = NULLSTR;
    //Currency  (max=3)
    private String cur33 = NULLSTR;
    //valdat in tag 32

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date dat32;
    //valdat in tag 33

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date dat33;
    //swift tag 71B  (max=35)
    private String tag71b = NULLSTR;
    //II_BIC in MTs  (max=12)
    private String ownbic = NULLSTR;
    //Tag 999 (max=65)
    private String tag999 = NULLSTR;
    //Status I-INCOMING, O-OUTGOING, N-NOTNEED  (max=1)
    private String clrsta = NULLSTR;

    private CrdgrpVo crdgrp;

    private CrtmodVo crtmod;

    private TrnVo cretrn;

    private Smh cresmh;

    private Smh bndsmh;

    private GleVo spcgle;

    private ActVO pacact;
    private Cpdgrp cpdgrp;
    private Gidgrp gidgrp;
    private Bcdgrp bcdgrp;
    private Brdgrp brdgrp;
    private Lidgrp lidgrp;
    private NosmodVo nosmod;

    @Override
    public void reset() {
        super.reset();
        if (crdgrp == null) {
            crdgrp = new CrdgrpVo();
        }
        crdgrp.reset();

        if (crtmod == null) {
            crtmod = new CrtmodVo();
        }
        crtmod.reset();

        if (cretrn == null) {
            cretrn = new TrnVo();
        }

        if (cresmh == null) {
            cresmh = new Smh();
        }

        if (bndsmh == null) {
            bndsmh = new Smh();
        }
        if (spcgle == null) {
            spcgle = new GleVo();
        }
        if (pacact == null) {
            pacact = new ActVO();
        }
        if (cpdgrp == null) {
            cpdgrp = new Cpdgrp();
        }
        cpdgrp.reset();
        if (gidgrp == null) {
            gidgrp = new Gidgrp();
        }
        gidgrp.reset();
        if (bcdgrp == null) {
            bcdgrp = new Bcdgrp();
        }
        bcdgrp.reset();
        if (brdgrp == null) {
            brdgrp = new Brdgrp();
        }
        brdgrp.reset();

        if (lidgrp == null) {
            lidgrp = new Lidgrp();
        }
        lidgrp.reset();
        if (nosmod == null) {
            nosmod = new NosmodVo();
        }
        nosmod.reset();
    }
}
